unit unitAdressen;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LR_Class, Forms, Controls, Graphics,
  Dialogs, ExtCtrls, Buttons, DBGrids, StdCtrls, DbCtrls, Db;

type

  { TfrmAdressen }

  TfrmAdressen = class(TForm)
    btnExit: TSpeedButton;
    btnZoek: TSpeedButton;
    btnPrint: TSpeedButton;
    btnFilter: TSpeedButton;
    btnToevoegen: TSpeedButton;
    btnVerwijderen: TSpeedButton;
    cboFilter: TComboBox;
    dsAdressen: TDatasource;
    DB_Datum: TDBEdit;
    edtSortering: TEdit;
    edtZoeken: TEdit;
    edtFilter: TEdit;
    DBGridAdressen: TDBGrid;
    DB_Land: TDBEdit;
    DB_VolleNaam: TDBEdit;
    DB_Markering: TDBCheckBox;
    DB_Categorie: TDBComboBox;
    DB_Opmerkingen: TDBMemo;
    DB_Email: TDBEdit;
    DB_Website: TDBEdit;
    DB_Plaats: TDBEdit;
    DB_Naam: TDBEdit;
    DB_Gsm: TDBEdit;
    DB_Tussenvoegsel: TDBEdit;
    DB_Telefoon: TDBEdit;
    DB_Voornaam: TDBEdit;
    DB_Adres: TDBEdit;
    DB_Postkode: TDBEdit;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    pnlData: TPanel;
    pnlButtons: TPanel;
    procedure btnExitClick(Sender: TObject);
    procedure btnFilterClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    procedure btnToevoegenClick(Sender: TObject);
    procedure btnVerwijderenClick(Sender: TObject);
    procedure btnZoekClick(Sender: TObject);
    procedure DBGridAdressenTitleClick(Column: TColumn);
    procedure DB_AdresExit(Sender: TObject);
    procedure DB_CategorieExit(Sender: TObject);
    procedure DB_EmailExit(Sender: TObject);
    procedure DB_GsmExit(Sender: TObject);
    procedure DB_LandExit(Sender: TObject);
    procedure DB_MarkeringExit(Sender: TObject);
    procedure DB_NaamExit(Sender: TObject);
    procedure DB_OpmerkingenExit(Sender: TObject);
    procedure DB_PlaatsExit(Sender: TObject);
    procedure DB_PostkodeExit(Sender: TObject);
    procedure DB_TelefoonExit(Sender: TObject);
    procedure DB_TussenvoegselExit(Sender: TObject);
    procedure DB_VoornaamExit(Sender: TObject);
    procedure DB_WebsiteExit(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure MaakNaam;

  private
    { private declarations }
  public
    { public declarations }
  end;

var
  frmAdressen: TfrmAdressen;

implementation

{$R *.frm}

uses unitDataModule;

{ TfrmAdressen }

procedure TfrmAdressen.MaakNaam;
begin
  if DB_Tussenvoegsel.Text = ''
  then begin     // Full name = Naam  or  Full name = Voornaam + ' ' + Naam
       if DB_Voornaam.Text = ''
       then DB_VolleNaam.Text := DB_Naam.Text
       else DB_VolleNaam.Text := DB_VoorNaam.Text + ' ' + DB_Naam.Text;
  end
  else begin     // Full name = Tussenvoegsel + ' ' + Naam  or Full name = Voornaam + ' ' + Tussenvoegsel + ' ' + Naam
       if DB_Voornaam.Text = ''
       then DB_VolleNaam.Text := DB_Tussenvoegsel.Text + ' ' + DB_Naam.Text
       else DB_VolleNaam.Text := DB_VoorNaam.Text + ' ' + DB_Tussenvoegsel.Text + ' ' + DB_Naam.Text;
  end;
end;

procedure TfrmAdressen.btnExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmAdressen.btnFilterClick(Sender: TObject);
var
  strSQL: String;
  strBoolean: String;
  strUpper: String;
  strMessage: String;
  crlf: String;
  bInvoerCorrect: Boolean;
begin
  bInvoerCorrect := True;     // Standard input is correct
  crlf := Chr(13) + Chr(10);  // Carriage return + Linefeed

  strMessage := 'U hebt een ongeldige filterwaarde opgegeven voor Markering.';
  strMessage := strMessage + crlf + 'Toegestane waarden zijn:';
  strMessage := strMessage + crlf + crlf + '"aan" en "uit"';
  strMessage := strMessage + crlf + '"waar" en "niet waar"';
  strMessage := strMessage + crlf + '"actief" en "inactief"';
  strMessage := strMessage + crlf + crlf + 'Verbeter de filterwaarde en klik daarna opnieuw op de filterknop.';

  strUpper := Uppercase(edtFilter.Text);

  if (cboFilter.ItemIndex = -1) or (strUpper = '')
  then begin
       strSQL := 'SELECT * FROM Adressen';  // Show all
  end
  else begin   // Construct special filter
       if cboFilter.ItemIndex = 5
       then begin
            if (strUpper = 'AAN') or (strUpper = 'ACTIEF') or (strUpper = 'WAAR')
            then strBoolean := '-1'
            else if (strUpper = 'UIT') or (strUpper = 'INACTIEF')  or (strUpper = 'NIET WAAR')
                 then strBoolean := '0'
                 else begin
                      MessageDlg(strMessage, mtWarning, [mbOK], 0);
                      strSQL := 'SELECT * FROM Adressen';  // Show all
                      bInvoerCorrect := False;
                 end;
       end;

       if bInvoerCorrect
       then begin   // Show filtered data
            case cboFilter.ItemIndex of
              0: strSQL := 'SELECT * FROM Adressen WHERE Naam LIKE ' + QuotedStr(edtFilter.Text + '%');
              1: strSQL := 'SELECT * FROM Adressen WHERE Categorie LIKE ' + QuotedStr(edtFilter.Text + '%');
              2: strSQL := 'SELECT * FROM Adressen WHERE Postkode LIKE ' + QuotedStr(edtFilter.Text + '%');
              3: strSQL := 'SELECT * FROM Adressen WHERE Plaats LIKE ' + QuotedStr(edtFilter.Text + '%');
              4: strSQL := 'SELECT * FROM Adressen WHERE Land LIKE ' + QuotedStr(edtFilter.Text + '%');
              5: strSQL := 'SELECT * FROM Adressen WHERE Markering = ' + strBoolean;
            end;
       end;
  end;

  DataModule1.sqlAdressen.Active := False;
  DataModule1.sqlAdressen.SQL.Text := strSQL;
  DataModule1.sqlAdressen.Active := True;
  DBGridAdressen.Refresh;
end;

procedure TfrmAdressen.btnPrintClick(Sender: TObject);
begin
  // Show Adresses list in preview
  DataModule1.frReportAdressen.LoadFromFile('Adressenlijst.lrf');
  DataModule1.frReportAdressen.ShowReport;

end;

procedure TfrmAdressen.btnToevoegenClick(Sender: TObject);
var
  strSQL: String;
begin
  // Execute query and refresh the grid
  strSQL := 'INSERT INTO Adressen (Naam) VALUES (' + QuotedStr('') + ')';
  DataModule1.sqlAdressen.Active := False;
  DataModule1.sqlAdressen.SQL.Text := strSQL;
  DataModule1.sqlAdressen.ExecSQL;

  strSQL := 'SELECT * FROM Adressen';
  DataModule1.sqlAdressen.SQL.Text := strSQL;
  DataModule1.sqlAdressen.Active := True;
  DataModule1.sqlAdressen.Last;
  DBGridAdressen.Refresh;
end;

procedure TfrmAdressen.btnVerwijderenClick(Sender: TObject);
begin
  DataModule1.sqlAdressen.Delete;
end;

procedure TfrmAdressen.btnZoekClick(Sender: TObject);
var
  strSQL: String;
begin
  // Search case-insensitive
  DataModule1.sqlAdressen.FilterOptions := [foCaseInsensitive];

  // Construct SQL statement including search argument
  strSQL := 'SELECT * FROM Adressen WHERE Naam LIKE ' + QuotedStr('%' + EdtZoeken.Text + '%') + ' OR ';
  strSQL := strSQL + 'Tussenvoegsel LIKE ' + QuotedStr('%' + EdtZoeken.Text + '%') + ' OR ';
  strSQL := strSQL + 'Voornaam LIKE ' + QuotedStr('%' + EdtZoeken.Text + '%') + ' OR ';
  strSQL := strSQL + 'Categorie LIKE ' + QuotedStr('%' + EdtZoeken.Text + '%') + ' OR ';
  strSQL := strSQL + 'Adres LIKE ' + QuotedStr('%' + EdtZoeken.Text + '%') + ' OR ';
  strSQL := strSQL + 'Postkode LIKE ' + QuotedStr('%' + EdtZoeken.Text + '%') + ' OR ';
  strSQL := strSQL + 'Plaats LIKE ' + QuotedStr('%' + EdtZoeken.Text + '%') + ' OR ';
  strSQL := strSQL + 'Land LIKE ' + QuotedStr('%' + EdtZoeken.Text + '%') + ' OR ';
  strSQL := strSQL + 'Telefoon LIKE ' + QuotedStr('%' + EdtZoeken.Text + '%') + ' OR ';
  strSQL := strSQL + 'Mobiel LIKE ' + QuotedStr('%' + EdtZoeken.Text + '%') + ' OR ';
  strSQL := strSQL + 'Email LIKE ' + QuotedStr('%' + EdtZoeken.Text + '%') + ' OR ';
  strSQL := strSQL + 'Website LIKE ' + QuotedStr('%' + EdtZoeken.Text + '%') + ' OR ';
  strSQL := strSQL + 'Opmerkingen LIKE ' + QuotedStr('%' + EdtZoeken.Text + '%');

  // Execute query and refresh the grid
  DataModule1.sqlAdressen.Active := False;
  DataModule1.sqlAdressen.SQL.Text := strSQL;
  DataModule1.sqlAdressen.Active := True;
  DBGridAdressen.Refresh;
end;

procedure TfrmAdressen.DBGridAdressenTitleClick(Column: TColumn);
var
  strSQL: String;
begin
  if edtSortering.Text = 'A'
  then begin
       edtSortering.Text := 'D';
       strSQL := 'SELECT * FROM Adressen ORDER BY Naam DESC, Voornaam DESC';
  end
  else begin
       edtSortering.Text := 'A';
       strSQL := 'SELECT * FROM Adressen ORDER BY Naam ASC, Voornaam ASC';
  end;

  // Execute query and refresh the grid
  DataModule1.sqlAdressen.Active := False;
  DataModule1.sqlAdressen.SQL.Text := strSQL;
  DataModule1.sqlAdressen.Active := True;
  DBGridAdressen.Refresh;
end;

procedure TfrmAdressen.DB_AdresExit(Sender: TObject);
begin
  DB_Datum.Text := DateToStr(Date);
end;

procedure TfrmAdressen.DB_CategorieExit(Sender: TObject);
begin
  DB_Datum.Text := DateToStr(Date);
end;

procedure TfrmAdressen.DB_EmailExit(Sender: TObject);
begin
  DB_Datum.Text := DateToStr(Date);
end;

procedure TfrmAdressen.DB_GsmExit(Sender: TObject);
begin
  DB_Datum.Text := DateToStr(Date);
end;

procedure TfrmAdressen.DB_LandExit(Sender: TObject);
begin
  DB_Datum.Text := DateToStr(Date);
end;

procedure TfrmAdressen.DB_MarkeringExit(Sender: TObject);
begin
  DB_Datum.Text := DateToStr(Date);
end;

procedure TfrmAdressen.DB_OpmerkingenExit(Sender: TObject);
begin
  DB_Datum.Text := DateToStr(Date);
end;

procedure TfrmAdressen.DB_PlaatsExit(Sender: TObject);
begin
  DB_Datum.Text := DateToStr(Date);
end;


procedure TfrmAdressen.DB_PostkodeExit(Sender: TObject);
begin
  DB_Datum.Text := DateToStr(Date);
end;

procedure TfrmAdressen.DB_TelefoonExit(Sender: TObject);
begin
  DB_Datum.Text := DateToStr(Date);
end;

procedure TfrmAdressen.DB_WebsiteExit(Sender: TObject);
begin
  DB_Datum.Text := DateToStr(Date);
end;

procedure TfrmAdressen.DB_NaamExit(Sender: TObject);
begin
  MaakNaam;
  DB_Datum.Text := DateToStr(Date);
end;

procedure TfrmAdressen.DB_TussenvoegselExit(Sender: TObject);
begin
  MaakNaam;
  DB_Datum.Text := DateToStr(Date);
end;

procedure TfrmAdressen.DB_VoornaamExit(Sender: TObject);
begin
  MaakNaam;
  DB_Datum.Text := DateToStr(Date);
end;

procedure TfrmAdressen.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  // Make changes definite in the database en close sqlAdressen again
  DataModule1.sqlAdressen.ApplyUpdates;
  DataModule1.DbConnection.Transaction.CommitRetaining;
  DataModule1.sqlAdressen.Active := False;
end;

end.

