unit unitStripalbums;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons, StdCtrls, DbCtrls, DBGrids, fpimage, db, lconvencoding, LR_Class;

type

  { TfrmStripalbums }

  TfrmStripalbums = class(TForm)
    btnExit: TSpeedButton;
    btnCover: TSpeedButton;
    btnFilter: TSpeedButton;
    btnPrint: TSpeedButton;
    btnUitgever: TButton;
    btnToevoegen: TSpeedButton;
    btnVerwijderen: TSpeedButton;
    btnZoek: TSpeedButton;
    btnSerie: TButton;
    cboFilter: TComboBox;
    dsStripuitgevers: TDatasource;
    dsStripseries: TDatasource;
    dsStripalbums: TDatasource;
    DB_InBezit: TDBCheckBox;
    DB_Uitgever: TDBLookupComboBox;
    DB_Titel: TDBEdit;
    DBGridStripalbums: TDBGrid;
    DB_Serie: TDBLookupComboBox;
    DB_Omschrijving: TDBMemo;
    DB_Tekenaar: TDBEdit;
    DB_Schrijver: TDBEdit;
    edtFilter: TEdit;
    edtSortering: TEdit;
    edtZoeken: TEdit;
    imgCover: TImage;
    Label1: TLabel;
    Label12: TLabel;
    Label15: TLabel;
    Label17: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Panel2: TPanel;
    SelectCover: TOpenDialog;
    Panel1: TPanel;
    pnlButtons: TPanel;
    procedure btnCoverClick(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure btnSerieClick(Sender: TObject);
    procedure btnUitgeverClick(Sender: TObject);
    procedure btnToevoegenClick(Sender: TObject);
    procedure btnVerwijderenClick(Sender: TObject);
    procedure dsStripalbumsDataChange(Sender: TObject; Field: TField);
    procedure FormActivate(Sender: TObject);
    procedure ReadImageFromDb;

    { private declarations }
  public
    { public declarations }
  end;

var
  frmStripalbums: TfrmStripalbums;
  fstream: Tstream;
  fpicture: Tjpegimage;

implementation

{$R *.frm}

uses unitDataModule, unitStripseries, unitStripuitgevers;

procedure TfrmStripalbums.ReadImageFromDb;
begin
  if not (tblobfield(DataModule1.sqlStripalbums.FieldByName('Cover')).IsNull)
  then begin
       fstream := DataModule1.sqlStripalbums.CreateBlobStream(DataModule1.sqlStripalbums.FieldByName('Cover'), bmread);
       fpicture := tjpegimage.create;

       try
         fpicture.LoadFromStream(fstream);
         imgCover.Picture.Assign(fpicture);
       finally
         fstream.Free;
         fpicture.Free;
       end;
  end;
end;

procedure TfrmStripalbums.btnExitClick(Sender: TObject);
begin
  // Make changes definite in the database
  DataModule1.sqlStripalbums.ApplyUpdates;
  DataModule1.DbConnection.Transaction.CommitRetaining;

  Close;
end;

procedure TfrmStripalbums.btnSerieClick(Sender: TObject);
begin
  // Show Comic Book series window
  FrmStripseries := TFrmStripseries.Create(Self);
  FrmStripseries.Showmodal;
  FrmStripseries.Release;
  FrmStripseries := nil;
end;

procedure TfrmStripalbums.btnUitgeverClick(Sender: TObject);
begin
  // Show Comic Book publishers window
  FrmStripuitgevers := TFrmStripuitgevers.Create(Self);
  FrmStripuitgevers.Showmodal;
  FrmStripuitgevers.Release;
  FrmStripuitgevers := nil;
end;

procedure TfrmStripalbums.btnToevoegenClick(Sender: TObject);
var
  strSQL: String;
begin
  // Add new record
  strSQL := 'INSERT INTO Stripalbums (Titel) VALUES (' + QuotedStr('') + ')';
  DataModule1.sqlStripalbums.Active := False;
  DataModule1.sqlStripalbums.SQL.Text := strSQL;
  DataModule1.sqlStripalbums.ExecSQL;

  // Now show all records again and position on last record
  strSQL := 'SELECT * FROM Stripalbums';
  DataModule1.sqlStripalbums.SQL.Text := strSQL;
  DataModule1.sqlStripalbums.Active := True;
  DataModule1.sqlStripalbums.Last;

  // Clear coverpicture and refresh DbGrid
  imgCover.Picture.Clear;
  DBGridStripalbums.Refresh;
end;

procedure TfrmStripalbums.btnVerwijderenClick(Sender: TObject);
begin
  DataModule1.sqlStripalbums.Delete;
  DataModule1.sqlStripalbums.ApplyUpdates;
end;

procedure TfrmStripalbums.dsStripalbumsDataChange(Sender: TObject; Field: TField);
begin
  ReadImageFromDb;
end;

procedure TfrmStripalbums.btnCoverClick(Sender: TObject);
var
  BlobField: TBlobField;
  Tmp_img: TImage;
begin
  if (SelectCover.Execute)
  then begin
       Tmp_img := TImage.Create(Self);
       BlobField := (DataModule1.sqlStripalbums.fieldbyname('Cover') as TBlobField);
       fstream := TMemoryStream.Create;

       try
         Tmp_img.Picture.LoadFromFile(utf8tocp936(SelectCover.FileName));
         Tmp_img.Picture.Graphic.SaveToStream(fstream);

         DataModule1.sqlStripalbums.Edit;
         BlobField.LoadFromStream(fstream);
         DataModule1.sqlStripalbums.Post;
         DataModule1.sqlStripalbums.ApplyUpdates;
       finally
         Tmp_img.Free;
       end;
  end;
end;

procedure TfrmStripalbums.FormActivate(Sender: TObject);
begin
  ReadImageFromDb;
  DataModule1.sqlStripalbums.Next;
  DataModule1.sqlStripalbums.Prior;
  DBGridStripAlbums.SetFocus;
end;

end.

